SystemOrganization addCategory: 'Seaside-GemStone-Core'!
SystemOrganization addCategory: 'Seaside-GemStone-Core-Notifications'!
SystemOrganization addCategory: 'Seaside-GemStone-Core-RequestHandling'!
SystemOrganization addCategory: 'Seaside-GemStone-Core-Utilities'!

!OrderedCollection methodsFor: '*seaside-gemstone-core' stamp: 'jgf 12/15/2008 14:24'!
restoreFromSnapshot: anObject
	super restoreFromSnapshot: anObject snapshotCopy! !

!OrderedCollection methodsFor: '*seaside-gemstone-core' stamp: 'jgf 12/15/2008 14:24'!
snapshotCopy
	^ self copy! !

WAObject subclass: #WAGemStoneMutex
	instanceVariableNames: 'semaphore owner'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-GemStone-Core-Utilities'!

!WAGemStoneMutex methodsFor: 'copying' stamp: 'dkh 11/20/2009 16:29'!
copy
	^ self species new! !

!WAGemStoneMutex methodsFor: 'mutual exclusion' stamp: 'dkh 11/20/2009 16:30'!
critical: aBlock
	| process |
	process := Processor activeProcess.
	^ (self owner == process)
		ifTrue: [ aBlock value ]
		ifFalse: [
			semaphore critical: [
				self owner: process.
				aBlock ensure: [ self owner: nil ] ] ]! !

!WAGemStoneMutex methodsFor: 'initialization' stamp: 'dkh 12/24/2009 16:02'!
initialize
	super initialize.
	semaphore := GRPlatform current semaphoreClass forMutualExclusion.
	owner := TransientValue value: nil.! !

!WAGemStoneMutex methodsFor: 'accessing' stamp: 'dkh 11/20/2009 16:29'!
owner
	^ owner value! !

!WAGemStoneMutex methodsFor: 'accessing' stamp: 'dkh 12/28/2009 06:57'!
owner: aProcessOrNil

	owner ~~  nil ifTrue: [ owner value: aProcessOrNil ]! !

!WAGemStoneMutex methodsFor: 'mutual exclusion' stamp: 'dkh 11/20/2009 16:30'!
terminateOwner
	self owner isNil ifFalse: [ GRPlatform current terminateProcess: self owner ]! !

!WACacheExpiryPolicy methodsFor: '*seaside-gemstone-core' stamp: 'dkh 12/28/2009 16:15'!
isExpiredUpdating:  anObject key: aString

	^self isExpired: anObject key: aString! !

!ObjectLogEntry methodsFor: '*seaside-gemstone-core-as yet unclassified' stamp: 'dkh 05/20/2008 12:09'!
deleteString

	^'here'! !

!ObjectLogEntry methodsFor: '*seaside-gemstone-core-as yet unclassified' stamp: 'dkh 05/20/2008 12:08'!
requestString

	^'-'! !

!GRObject methodsFor: '*seaside-gemstone-core' stamp: 'dkh 11/06/2009 09:50'!
asString

	^self printString! !

!GRObject methodsFor: '*seaside-gemstone-core' stamp: 'dkh 11/06/2009 09:50'!
printOn: aStream
	
	aStream nextPutAll: super asString! !

!WARetryHttpRequest methodsFor: '*seaside-gemstone-core' stamp: 'dkh 03/21/2008 08:56'!
logMessage

	^'Retry Http request'! !

WARetryHttpRequest subclass: #WASessionLockNotAcquiredException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-GemStone-Core-Notifications'!

!WASessionLockNotAcquiredException methodsFor: 'logging' stamp: 'dkh 03/21/2008 08:56'!
logMessage

	^'Lock not acquired - retrying'! !

!MessageSend methodsFor: '*seaside-gemstone-core' stamp: 'DaleHenrichs 06/04/2010 14:25'!
renderOn: html

	self value: html! !

!GRGemStonePlatform methodsFor: '*seaside-gemstone-core' stamp: 'dkh 12/23/2009 12:26'!
retryCount

	^10! !

!GRGemStonePlatform methodsFor: '*seaside-gemstone-core' stamp: 'dkh 12/23/2009 12:26'!
retryDelay

	^10! !

!GRGemStonePlatform methodsFor: '*seaside-gemstone-core' stamp: 'dkh 12/23/2009 14:40'!
seasideLogServerStart: label port: port

	self doTransaction: [
		(ObjectLogEntry
			info: label
			object:
				'pid: ', (System gemVersionReport at: 'processId') printString, ' ',
				'port: ', port printString) addToLog ]! !

!GRGemStonePlatform methodsFor: '*seaside-gemstone-core' stamp: 'DaleHenrichs 08/04/2010 16:46'!
seasideProcessRequest: aNativeRequest adaptor: adaptor resultBlock: resultBlock
	
	| result |
	[ | retryCount result count |
		retryCount := self retryCount.
		count := 1.
		retryCount timesRepeat: [
			(result := self
				seasideProcessRequestWithRetry: aNativeRequest 
				resultBlock: resultBlock) ~~ nil
					ifTrue: [ ^result ].
				System _sessionCacheStatAt: 2 put: ((System _sessionCacheStatAt: 2) + 1). "requests retried"
				(Delay forMilliseconds: self retryDelay * count) wait.
				count := count * 10 ].
		"exceeded retry limit"
		^adaptor internalServerErrorMessage: 'Too many retries: ', (retryCount+1) printString ] 
			on: Error 
			do: [:ex |
				self doAbortTransaction.
				result := adaptor internalServerErrorMessage: ex description.
				"Do an explicit return. Because of the abort above, the default action for an exception (resume) is set. see bug39246."
				ex return: nil ].
	^result! !

!GRGemStonePlatform methodsFor: '*seaside-gemstone-core' stamp: 'DaleHenrichs 07/30/2010 15:07'!
seasideProcessRequestWithRetry: aNativeRequest resultBlock: resultBlock
	"answer nil to retry request"

	| result retryRequest retryException |
	self transactionMutex critical: [
		System inTransaction
			ifTrue:[ self doAbortTransaction ]
			ifFalse: [ self doBeginTransaction ].
		retryRequest := false.
		System _sessionCacheStatAt: 0 put: ((System _sessionCacheStatAt: 0) + 1). "requests received"
		[ result := resultBlock value: aNativeRequest ]
				on: WARetryHttpRequest, SafelyPerformBlockRequiringAbort
				do: [:ex |
					retryRequest := true.
					retryException := ex ].
retryRequest 
				ifTrue: [
					(retryException isKindOf: SafelyPerformBlockRequiringAbort)
						ifTrue: [
							"Abort and start a transaction"
							self doBeginTransaction.
							retryException block value: true.
							"block is expected to do it's own commit, but make sure we've left transaction mode"
							self doAbortTransaction ]
						ifFalse: [
							"lock not acquired - unwind the stack to this point and leave transaction mode"
							self doAbortTransaction.
							self 
								saveLogEntry: (WAObjectLogEntry trace: retryException logMessage request: aNativeRequest object: retryException description) 
								shouldCommit: true ].
					^nil "retry request" ].
		self doCommitTransaction
			ifFalse: [ | conflicts | 
				conflicts := System transactionConflicts.
				self doAbortTransaction.
				self 
					saveLogEntry: (WAObjectLogEntry warn: 'Commit failure - retrying' request: aNativeRequest object: conflicts)  
					shouldCommit: true.
				^nil "retry request"].
		System _sessionCacheStatAt: 1 put: ((System _sessionCacheStatAt: 1) + 1). "requests processed (successful)"
].
	^result! !

WARequestContext subclass: #WAGemStoneRequestContext
	instanceVariableNames: 'forDebugging'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-GemStone-Core-RequestHandling'!

!WAGemStoneRequestContext methodsFor: 'initialization' stamp: 'DaleHenrichs 06/21/2010 13:35'!
destroy
	"Clear references to objects when the receiver is no longer required. This helps avoid circular references and reduces memory consumption. This method is called by the ServerAdaptor after request processing is finished."
	
	self forDebugging ifFalse: [ super destroy ]! !

!WAGemStoneRequestContext methodsFor: 'accessing' stamp: 'DaleHenrichs 06/21/2010 13:34'!
forDebugging

	forDebugging == nil ifTrue: [ forDebugging := false ].
	^forDebugging! !

!WAGemStoneRequestContext methodsFor: 'updating' stamp: 'DaleHenrichs 06/21/2010 13:35'!
forDebugging: aBoolean

	forDebugging := aBoolean! !

!UnorderedCollection methodsFor: '*Seaside-GemStone-Core' stamp: 'dkh 03/03/2008 14:27'!
restoreFromSnapshot: anObject
	"restore from a shallow copy"
	| class x |
	class := self class.
	(UnorderedCollection instSize + 1) to: class instSize do:
		[:i | self instVarAt: i put: (anObject instVarAt: i) ].
	class isVariable
		ifTrue: [
			self removeAll: self.
			anObject do: [:each | self add: each ].
		].! !

!UnorderedCollection methodsFor: '*Seaside-GemStone-Core' stamp: 'dkh 03/03/2008 14:24'!
snapshotCopy
	^ self copy! !

RemoteDebuggerLogEntry subclass: #WAObjectLogEntry
	instanceVariableNames: 'request'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-GemStone-Core'!

!WAObjectLogEntry class methodsFor: 'instance creation' stamp: 'dkh 05/20/2008 08:31'!
debug: aString request: aWARequest object: anObject

	^(self debug: aString object: anObject)
		request: aWARequest;
		yourself! !

!WAObjectLogEntry class methodsFor: 'instance creation' stamp: 'dkh 05/20/2008 08:31'!
error: aString request: aWARequest continuation: aGsProcess

	^(self error: aString continuation: aGsProcess)
		request: aWARequest;
		yourself! !

!WAObjectLogEntry class methodsFor: 'instance creation' stamp: 'dkh 05/20/2008 08:31'!
error: aString request: aWARequest object: anObject

	^(self error: aString object: anObject)
		request: aWARequest;
		yourself! !

!WAObjectLogEntry class methodsFor: 'instance creation' stamp: 'dkh 05/20/2008 08:31'!
fatal: aString request: aWARequest object: anObject

	^(self fatal: aString object: anObject)
		request: aWARequest;
		yourself! !

!WAObjectLogEntry class methodsFor: 'instance creation' stamp: 'dkh 05/20/2008 08:31'!
info: aString request: aWARequest object: anObject

	^(self info: aString object: anObject)
		request: aWARequest;
		yourself! !

!WAObjectLogEntry class methodsFor: 'instance creation' stamp: 'dkh 05/20/2008 08:31'!
trace: aString request: aWARequest object: anObject

	^(self trace: aString object: anObject)
		request: aWARequest;
		yourself! !

!WAObjectLogEntry class methodsFor: 'instance creation' stamp: 'DaleHenrichs 06/20/2010 10:25'!
transcript: aString request: aWARequest object: anObject

	^(self transcript: aString object: anObject)
		request: aWARequest;
		yourself! !

!WAObjectLogEntry class methodsFor: 'instance creation' stamp: 'dkh 05/20/2008 08:31'!
warn: aString request: aWARequest object: anObject

	^(self warn: aString object: anObject)
		request: aWARequest;
		yourself! !

!WAObjectLogEntry methodsFor: 'testing' stamp: 'DaleHenrichs 06/20/2010 16:03'!
isResumable
	"disable resume for continuations until bugs relating to resuming are fixed.
	 Issue 128: http://code.google.com/p/glassdb/issues/detail?id=128"
	
	^false! !

!WAObjectLogEntry methodsFor: 'accessing' stamp: 'dkh 05/20/2008 08:32'!
request

	^request! !

!WAObjectLogEntry methodsFor: 'accessing' stamp: 'dkh 05/20/2008 08:32'!
request: aWARequest

	request := aWARequest! !

!WAObjectLogEntry methodsFor: 'accessing' stamp: 'dkh 05/20/2008 12:09'!
requestString

	self request == nil ifTrue: [ ^super requestString ].
	^self request url asString! !

!WAExceptionHandler methodsFor: '*seaside-gemstone-core' stamp: 'dkh 09/15/2009 09:37'!
errorCategoryToCatch

	^self class exceptionSelector! !

!WAExceptionHandler methodsFor: '*seaside-gemstone-core' stamp: 'dkh 09/15/2009 09:38'!
errorNumberToCatch

	^nil! !

!ExecutableBlock methodsFor: '*Seaside-GemStone-Core' stamp: 'dkh 03/03/2008 15:29'!
handleRequest: aRequest
	^ self value: aRequest! !

!ExecutableBlock methodsFor: '*Seaside-GemStone-Core' stamp: 'DaleHenrichs 06/17/2010 15:08'!
renderOn: aRenderer
	numberArgs == 0 
		ifTrue: [self value]
		ifFalse: [self value: aRenderer]! !

!WACache methodsFor: '*seaside-gemstone-core' stamp: 'dkh 12/28/2009 14:53'!
gemstoneReap
	"Iterate through the cache and remove objects that have expired."

	"In GemStone, this method is performed by a separate maintenance VM, 
	 so we are already in transaction (assumed to be running in #autoBegin 
	 transactionMode) and do not have to worry about acquiring the TransactionMutex.
	Since we are using reducedConflict dictionaries in the first place, we will remove the keys
	and values from the existing dictionaries without using the mutex."

	| expired count platform |
	expired := OrderedCollection new.
	objectsByKey associationsDo: 
			[ :assoc | 
			(self expiryPolicy 
				isExpiredUpdating: assoc value
				key: assoc key) 
				ifTrue: [  
					self 
						notifyRemoved: assoc value
						key: assoc key.
					expired add:  assoc ]].
	count := 0.
	platform := GRPlatform current.
	expired do: [:assoc | 
		count := count + 1.
		objectsByKey removeKey: assoc key.
		keysByObject removeKey: assoc value ifAbsent: [].
		(count \\ 100 == 0) ifTrue: [ platform doCommitTransaction ]].
	count ~~ 0 ifTrue: [ platform doCommitTransaction ].
	^expired size! !

!String methodsFor: '*seaside-gemstone-core' stamp: 'dkh 03/03/2008 15:04'!
trimBlanks
	^self withBlanksTrimmed! !

!PositionableStream methodsFor: '*seaside-gemstone-core' stamp: 'jgf 05/05/2009 13:10'!
asMIMEDocument
	^self asMIMEDocumentType: 'text/plain'! !

!PositionableStream methodsFor: '*seaside-gemstone-core' stamp: 'dkh 03/03/2008 15:48'!
asMIMEDocumentType: mimeType
	^MIMELocalFileDocument contentType: mimeType contentStream:  self! !

!PositionableStream methodsFor: '*seaside-gemstone-core' stamp: 'jgf 05/05/2009 13:01'!
seasideMimeDocument
	^ self contents seasideMimeDocument! !

!PositionableStream methodsFor: '*seaside-gemstone-core' stamp: 'DaleHenrichs 06/21/2010 14:55'!
seasideMimeDocumentType: aMimetype

	^self seasideMimeDocument mimeType: aMimetype; yourself! !

!PositionableStream methodsFor: '*seaside-gemstone-core' stamp: 'DaleHenrichs 06/17/2010 14:35'!
seasideNextLine

| result cr lf char |
result := itsCollection species new.
lf := Character lf.
[self atEnd not _and: [(char := self next) ~~ lf]] whileTrue: [
  result add: char
].
^result! !

!PositionableStream methodsFor: '*seaside-gemstone-core' stamp: 'dkh 03/03/2008 16:22'!
upToAndSkipThroughAll: aCollection 
	"Needed for Seaside ports to other dialects where #upToAll: may have
	different semantics"
	| res |
	res := self upToAll: aCollection.
	self atEnd ifFalse: [ self skip: aCollection size ].
	^res! !

Object subclass: #GsContext
	instanceVariableNames: 'continuation level method source mySelf receiver'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-GemStone-Core'!

!GsContext class methodsFor: 'instance creation' stamp: 'dkh 02/28/2008 15:13'!
fromContinuation: aContinuation atLevel: anInteger

^self new continuation: aContinuation level: anInteger! !

!GsContext class methodsFor: 'instance creation' stamp: 'dkh 02/28/2008 15:13'!
fromLevel: anInteger

^self new continuation: (GsProcess continuationFromLevel: anInteger)  level: 1! !

!GsContext methodsFor: 'formatting' stamp: 'dkh 02/28/2008 15:15'!
asString

	^self fullPrintString! !

!GsContext methodsFor: 'initialization' stamp: 'dkh 02/28/2008 15:16'!
continuation: aContinuation level: anInteger

	continuation := aContinuation.
	level := anInteger.
	"these instance variables are populated for the WAWalkback use"
	method := (continuation _localFrameContentsAt: level) at: 1.
	source := method sourceString.
	receiver := (continuation _localFrameContentsAt: level) at: 10.
	mySelf := (continuation _localFrameContentsAt: level) at: 8.! !

!GsContext methodsFor: 'accessing' stamp: 'dkh 02/28/2008 15:14'!
fullPrintString


^continuation _reportAt: level! !

!GsContext methodsFor: 'formatting' stamp: 'DaleHenrichs 06/04/2010 17:22'!
greaseString

	^self fullPrintString! !

!GsContext methodsFor: 'accessing' stamp: 'dkh 02/28/2008 15:15'!
method

^method! !

!GsContext methodsFor: 'accessing' stamp: 'dkh 02/28/2008 15:15'!
receiver

^receiver! !

!GsContext methodsFor: 'accessing' stamp: 'dkh 02/28/2008 15:15'!
sender

continuation stackDepth == level ifTrue: [^nil].
^self class fromContinuation: continuation atLevel: level + 1! !

!GsContext methodsFor: 'accessing' stamp: 'dkh 02/28/2008 15:15'!
tempAt: index

| ar |
ar := (continuation _localFrameContentsAt: level).
ar size < (10 + index) ifTrue: [^nil].
^ar at: (10 + index)! !

!GsContext methodsFor: 'accessing' stamp: 'dkh 02/28/2008 15:14'!
tempNames

^(continuation _localFrameContentsAt: level) at: 9! !

!Object methodsFor: '*Seaside-GemStone-Core' stamp: 'DaleHenrichs 06/03/2010 11:18'!
restoreFromSnapshot: anObject
	"Default implementation : restore from a shallow copy"
	| class |
	class := self class.
	1 to: class instSize do:
		[:i | self instVarAt: i put: (anObject instVarAt: i) ].
	class isVariable
		ifTrue:
			[class isIndexable ifFalse: [self error: 'not indexable: ', class printString].
			self basicSize ~= anObject basicSize 
				ifTrue: [ self size: anObject basicSize - class instSize ].
			1 to: self basicSize - class instSize do:
				[:i | self basicAt: i put: (anObject basicAt: i) ]].! !

!Object methodsFor: '*Seaside-GemStone-Core' stamp: 'DaleHenrichs 06/03/2010 11:18'!
snapshotCopy
	^ self shallowCopy! !

!Bag methodsFor: '*seaside-gemstone-core' stamp: 'jgf 12/15/2008 14:24'!
restoreFromSnapshot: anObject
	super restoreFromSnapshot: anObject snapshotCopy! !

!Bag methodsFor: '*seaside-gemstone-core' stamp: 'jgf 12/15/2008 14:24'!
snapshotCopy
	^ self copy! !

!GRPackage class methodsFor: '*seaside-gemstone-core' stamp: 'DaleHenrichs 06/03/2010 12:32'!
seasideGemStoneCore
	^ self new
		name: 'Seaside-GemStone-Core';
		addDependency: 'Seaside-Core';
		url: #gemstoneUrl;
		yourself! !

!CharacterCollection methodsFor: '*seaside-gemstone-core' stamp: 'DaleHenrichs 02/16/2011 16:50'!
asCapitalizedPhrase
	|read words currentWord capitalizedWord|
	(self noneSatisfy: [:ea | ea isLowercase] ) ifTrue: [^ self].
	words := WriteStream on: String new.
	read := ReadStream on: self.
	[read atEnd] whileFalse:
		[currentWord := WriteStream on: String new.
		currentWord nextPut: read next.
		[|x| x := read peek. x isNil or: [x isUppercase]] whileFalse:
			[currentWord nextPut: read next].
		capitalizedWord := currentWord contents capitalized.
			(#(Of In At A Or To By) includes: capitalizedWord)
				ifTrue: [capitalizedWord := capitalizedWord asLowercase].
		words nextPutAll: capitalizedWord.
		words nextPutAll: ' '].
	words skip: -1.
	^ words contents! !

!CharacterCollection methodsFor: '*seaside-gemstone-core' stamp: 'DaleHenrichs 06/04/2010 10:08'!
encodeOn: aDocument
	aDocument xmlEncoder nextPutAll: self! !

!CharacterCollection methodsFor: '*seaside-gemstone-core' stamp: 'dkh 03/03/2008 15:03'!
renderOn: aRenderer
	aRenderer text: self! !

!CharacterCollection methodsFor: '*seaside-gemstone-core' stamp: 'DaleHenrichs 02/16/2011 16:49'!
seasideUrl
	^ WAUrl absolute: self! !

!MIMEDocument methodsFor: '*seaside-gemstone-core' stamp: 'dkh 03/03/2008 15:37'!
asMIMEDocument
	^self! !

!MIMEDocument methodsFor: '*seaside-gemstone-core' stamp: 'dkh 03/03/2008 15:37'!
asMIMEDocumentType: mimeType
	^self! !

!MIMEDocument methodsFor: '*seaside-gemstone-core' stamp: 'DaleHenrichs 06/21/2010 14:56'!
seasideMimeDocument

	^WAMimeDocument on: self content mimeType: self contentType! !

!MIMEDocument methodsFor: '*seaside-gemstone-core' stamp: 'DaleHenrichs 06/21/2010 14:56'!
seasideMimeDocumentType: aMimetype

	^self seasideMimeDocument mimeType: aMimetype; yourself! !

!WAServerAdaptor class methodsFor: '*seaside-gemstone-core' stamp: 'dkh 12/23/2009 16:17'!
startGemServerOn: portInteger
	"use this method to start adaptor in a separate gem.
	 use #startOn: if starting from development vm"

	| adaptor |
	GRPlatform current seasideLogServerStart: self class name port: portInteger.
	adaptor := self port: portInteger.
	"The method not expected to return"
	adaptor start! !

!AbstractDictionary methodsFor: '*Seaside-GemStone-Core' stamp: 'dkh 03/03/2008 14:26'!
restoreFromSnapshot: aDictionary
	self keys do: [ :key | self removeKey: key ].
	aDictionary keysAndValuesDo: [ :key :value | self at: key put: value ]! !

!AbstractDictionary methodsFor: '*Seaside-GemStone-Core' stamp: 'dkh 03/03/2008 14:22'!
snapshotCopy
	| n |
	n := self class new: self tableSize.
	self keysAndValuesDo: [:k :v | n at: k put: v].
	^n! !

!AbstractDictionary methodsFor: '*Seaside-GemStone-Core' stamp: 'dkh 03/03/2008 14:21'!
valuesCollect: aBlock
	| result |
	result := self species new: self size.
	self keysAndValuesDo: [ :key :value |
		result at: key put: (aBlock value: value) ].
	^ result! !

!Set methodsFor: '*seaside-gemstone-core' stamp: 'jgf 12/15/2008 14:24'!
restoreFromSnapshot: anObject
	super restoreFromSnapshot: anObject snapshotCopy! !

!Set methodsFor: '*seaside-gemstone-core' stamp: 'jgf 12/15/2008 14:24'!
snapshotCopy
	^ self copy! !
